' Initialisierung fuer monopolz
' Die Datei enthaelt alle Deklarationen, die Grundeinstellungen und den Destructor
' sowie die Ladeoptionen fuer das Spielbrett und die Sprachdatei
const VERSION = "1.02.090116"
dim shared ende as byte

if command = "--version" or command = "-v" then
  print "MonopolZ Version " & VERSION & ", compiliert am ";
  print mid(__DATE__, 4, 2) & "." & left(__DATE__, 2) & "." & right(__DATE__, 4) & ", " & __TIME__
  print
  end
elseif command = "--help" or command = "-h" then
  print "MonopolZ Version " & VERSION
  print "geschrieben von Stephan Markthaler"
  print "Das Programm steht unter der GPL, Version 3."
  print
  print "Ein Aufruf ohne Parameter startet das Spiel."
  print "Fuer Informationen lesen Sie die ReadMe-Datei."
  print
  print "moegliche Parameter:"
  print "--help    oder -h: zeigt diesen Hilfstext an."
  print "--version oder -v: zeigt die Versionsnummer."
  print
  end
end if

type TypIcon
  as any pointer grafik
  as ushort x, y
end type
type TypGrafikfeld
  as ushort x, y, b, h
end type
type TypFeld
  ' Art: 0:nichts  1:Strasse  2:Karte  3:Steuer  255:Gefaengnis
  as ubyte nr, art, gruppe, hauszahl, hotelzahl, gehezu, gehezueigen, geldsammelpunkt
  as ubyte besitzer, haeuser, status
  as string name, gruppenname, farbe, hgfarbe, rentmath
  as uinteger farb_rgb, hg_rgb
  as short einkommen, preis, hauspreis, miete(99), sammelgeld
  as TypGrafikfeld position, statusleiste
  as TypIcon icon
end type
type TypGruppe
  as string name, farbe, hgfarbe, rentmath, grundstuecke
  as uinteger preis, hauspreis
  as ushort hauszahl, hotelzahl, miete(99)
  as ubyte minbesitz
end type
type TypKartenstapel
  as string name, farbe, hgfarbe
  as ubyte position
end type
type TypKarte
  as string name, gehezugruppe, rentmath
  as ubyte gehezufeld, befreiung, behaltbar
  as byte gehe
  as short zahle, zahleallen, zahlehotel, zahlehaus
end type
type TypWurf
  as ushort w1, w2
end type
type TypSpieler
  as integer geld, vermoegen, kredit, belastbar
  as ubyte feld, nr, typ
  as uinteger farbe
  as string name
end type
type TypSpielfeld
  dim as string name, autor, beschreibung, version, programmversion
  dim as ushort startgeld
  dim as ubyte min, max
end type

dim shared AIfeldzahl as ubyte, AImietsumme as uinteger, AImietniveau as ushort
dim shared AIrestfelder as ubyte, AIrestpreissumme as uinteger
dim shared as string spielname, spielbeschreibung, spielautor, spielversion, spielfarbe, spielhgfarbe
dim shared as ushort Startspieler, Rundenzahl, spielgeld, spielkredit = 0, spielzins
dim shared as ubyte spielhaus, spielhotel, spielmin, spielmax, spielstart, ausgeschieden
dim shared as TypGruppe gruppe(100)
dim shared as TypFeld feld(100)
dim shared as TypKartenstapel kartenstapel(9)
dim shared as TypKarte karte(9, 255)
dim shared as ubyte AnzahlGruppen, AnzahlFelder, AnzahlStapel, AnzahlKarten(9), AnzahlSpieler
dim shared as ubyte MaxHauszahl = 5, MaxKredite = 3, Jail, curunit = 10
dim shared as TypSpieler spieler(20)
dim shared as ubyte i, j, k, dbyte, Infozeile
dim shared as TypIcon menuleiste, wuerfelseite, wuerfelauge, button_ja, button_nein, button_ende
dim shared as TypIcon button_ok, button_abbruch, button_plus, button_minus, button_farbe
dim shared as string text, dstring, gefaengnis
dim shared as string MSG_optTitle, MSG_optLanguage, MSG_optBoard, MSG_optPlayerName, MSG_optType(4)
dim shared as string MSG_optColor, MSG_optAim, MSG_optAim1, MSG_optAim2, MSG_optAim3
dim shared as string MSG_errorFile, MSG_errorGroups, MSG_errorFields, MSG_errorDecks
dim shared as string MSG_errorCards, MSG_errorUnused, MSG_errorIgnore, MSG_errorAddFields, MSG_errorPart
dim shared as string MSG_errorVersion, MSG_noteLog, MSG_noteAuthor, MSG_noteStart, MSG_askNewGame
dim shared as string MSG_house, MSG_houses, MSG_hotel, MSG_hotels, MSG_street, MSG_streets, MSG_minprop
dim shared as string MSG_jail, MSG_price, MSG_houseprice, MSG_rent, MSG_name
dim shared as string MSG_cash, MSG_capital, MSG_currency, MSG_turn
dim shared as string MSG_info, MSG_position, MSG_inJail, MSG_score, MSG_double, MSG_threeDoubles
dim shared as string MSG_outOfJail, MSG_onceAgain, MSG_payJail1, MSG_payJail2, MSG_noMoney, MSG_withdraw
dim shared as string MSG_payDept1, MSG_payDept2, MSG_money, MSG_drawCard, MSG_taxFixed, MSG_getFixed
dim shared as string MSG_taxPercent, MSG_getPercent, MSG_taxMixed, MSG_getMixed
dim shared as string MSG_taxCollect, MSG_getPay, MSG_noCollect, MSG_passGo, MSG_collectGo, MSG_payGo
dim shared as string MSG_infoGo1, MSG_infoGo2
dim shared as string MSG_collectCard, MSG_payCard, MSG_reachField, MSG_justVisit, MSG_collectField
dim shared as string MSG_payRent, MSG_noRent, MSG_forSale, MSG_askBuy, MSG_buy, MSG_notBuy
dim shared as string MSG_clickToBuy, MSG_clickToSell, MSG_pressESC, MSG_rounds, MSG_win, MSG_gameOver
dim shared as string MSG_credit, MSG_trade, MSG_tradeInstruction, MSG_tradeMoney, MSG_tradeOK
dim shared as string MSG_tradeMakeDeal, MSG_tradeBadDeal, MSG_tradeNoDeal
dim shared as string MSG_humanBroke, MSG_aiBroke, MSG_aiBuy, MSG_aiSell, MSG_aiMortgage, MSG_aiWipeOff
dim shared as ubyte sprache = 0, spielfeld = 0, spielziel = 0
dim shared as byte pasch, _DEBUG = 0
if command = "-d" then _DEBUG = 1
spielhgfarbe="ffffff"
Infozeile = 0
randomize timer

declare function MIN(byval x as short, byval y as short) as short
declare function MAX(byval x as short, byval y as short) as short
declare function aktion(byval opt as ubyte = 0) as ubyte
declare sub bildladen(byval name as string, byref speicher as TypIcon)
declare sub computerEntschuldung(byref wer as TypSpieler)
declare function computerFeldkauf(byref wer as TypSpieler, byref wo as TypFeld) as byte
declare function computerHandel(byval aktor as ubyte, byval partner as ubyte, byval geldbetrag as short) as ubyte
declare sub computerKaufen(byval dran as ubyte)
declare sub destruct
declare sub entschuldung(byref wer as TypSpieler)
declare sub feldinfo(byval ort as TypFeld)
declare function feldwert(byref ort as TypFeld, byref wer as TypSpieler) as single
declare sub geheum(byref wer as TypSpieler, byval wieviel as byte)
declare sub gehezu(byref wer as TypSpieler, byval wohin as ubyte)
declare sub gehezugruppe(byref wer as TypSpieler, byval wohin as string)
declare sub gesamtinfo
declare sub handel(byref wer as TypSpieler)
declare function handel_wertberechnung(spielernr as ubyte) as integer
declare function in(byval feld as TypGrafikfeld, byval x as ushort, byval y as ushort) as ubyte
declare sub info overload (byval ausgabe as string = "\n", byval opt as ubyte = 0)
declare sub info(byval farbe as uinteger, byval ausgabe as string, byval opt as ubyte = 0)
declare function janein as ubyte
declare sub kaufen(byref wer as TypSpieler)
declare sub ladeTexte(byval sprache as string)
declare sub mark (byval ort as TypGrafikfeld, byval farbe as uinteger = &hffffff)
declare function meldung(byval text as string = "", byval eingabe as string = "") as string
declare function mietberechnung overload (byval ort as TypFeld, byval wurf as TypWurf) as short
declare function mietberechnung(byval ort as TypFeld, byval wurf as ubyte) as short
declare function mietberechnung(byval ort as TypFeld, byval wurf as ubyte, byval anz as ubyte, byval anz2 as ubyte, byval haus as ubyte) as short
declare function msg(byval text as string, byval var1 as string, byval var2 as string = "", byval var3 as string = "") as string
declare function neu(byval dateiname as string) as ubyte
declare function neuesGrafikfeld(byval x as ushort, byval y as ushort, byval b as ushort, byval h as ushort) as TypGrafikfeld
declare sub optionen(byval opt as ubyte)
declare sub opt_spielerzahlAnpassen(textfelder() as TypGrafikfeld, byval mini as ubyte, byval maxi as ubyte)
declare function pruefeSpielende(byval opt as ubyte = 0, byval dran as ubyte = 0) as byte
declare sub rgb_plus(byref r as ubyte, byref g as ubyte, byref b as ubyte)
declare sub rgb_minus(byref r as ubyte, byref g as ubyte, byref b as ubyte)
declare sub spiel
declare function spiel_karteziehen(byref wer as TypSpieler) as string
declare sub spiel_steuernzahlen(byref wer as TypSpieler)
declare function spielerwurf(byref wer as TypSpieler) as TypWurf
declare sub spielerinfo(byval wer as TypSpieler)
declare sub textausgabe(byref ort as TypGrafikfeld, byref text as string, byref farbe as integer = &hffffff)
declare sub verkaufen(byref wer as TypSpieler, byval wert as ushort = 0)
declare function wartetaste as string
declare function werfen as TypWurf
declare sub zeichne(byval wert as ubyte)
declare sub zeigewurf(byval w1 as ubyte, byval w2 as ubyte)

screen 19, 32
width 100, 75
bildladen "menu.bmp", menuleiste
bildladen "wuerfel1.bmp", wuerfelseite
bildladen "wuerfel2.bmp", wuerfelauge
bildladen "button_ja.bmp", button_ja
bildladen "button_nein.bmp", button_nein
bildladen "button_ok.bmp", button_ok
bildladen "button_abbruch.bmp", button_abbruch
bildladen "button_ende.bmp", button_ende
bildladen "button_plus.bmp", button_plus
bildladen "button_minus.bmp", button_minus
bildladen "button_farbe.bmp", button_farbe

dim shared as TypGrafikfeld Gspielfeld, Gmenu, Ginfo, Gnachricht, Gueberblick
dim shared as TypGrafikfeld Mwurf, Mhandel, Mkauf, Mverkauf, Mladen, Mspeichern, Mneu, Moptionen
dim shared as TypGrafikfeld buttonfeld_ja, buttonfeld_nein, buttonfeld_ok, buttonfeld_ok2, buttonfeld_abbruch
dim shared as TypGrafikfeld buttonfeld_abbruch2, buttonfeld_plus, buttonfeld_minus, buttonfeld_wert
Gspielfeld          = neuesGrafikfeld(  0,   0, 540, 540)
Gueberblick         = neuesGrafikfeld(130, 130, 280, 280)
Gmenu               = neuesGrafikfeld(540,   0, 260,  60)
Ginfo               = neuesGrafikfeld(540,  60, 260, 480)
Gnachricht          = neuesGrafikfeld(  0, 540, 800,  60)
Mwurf               = neuesGrafikfeld(Gmenu.x,     Gmenu.y,    50, 30)
Mhandel             = neuesGrafikfeld(Gmenu.x,     Gmenu.y+30, 50, 30)
Mkauf               = neuesGrafikfeld(Gmenu.x+50,  Gmenu.y,    50, 30)
Mverkauf            = neuesGrafikfeld(Gmenu.x+50,  Gmenu.y+30, 50, 30)
Mladen              = neuesGrafikfeld(Gmenu.x+160, Gmenu.y,    50, 30)
Mspeichern          = neuesGrafikfeld(Gmenu.x+160, Gmenu.y+30, 50, 30)
Mneu                = neuesGrafikfeld(Gmenu.x+210, Gmenu.y,    50, 30)
Moptionen           = neuesGrafikfeld(Gmenu.x+210, Gmenu.y+30, 50, 30)
buttonfeld_ja       = neuesGrafikfeld(Gnachricht.x+Gnachricht.b-70, Gnachricht.y+7, button_ja.x, button_ja.y)
buttonfeld_nein     = neuesGrafikfeld(buttonfeld_ja.x, buttonfeld_ja.y+button_ja.y+5, _
                                      button_nein.x, button_nein.y)
buttonfeld_ok       = neuesGrafikfeld(Ginfo.x+Ginfo.b\2-button_ok.x\2, Ginfo.y+Ginfo.h-40, _
                                      button_ok.x, button_ok.y)
buttonfeld_ok2      = neuesGrafikfeld(Ginfo.x+50, Ginfo.y+Ginfo.h-40, button_ok.x, button_ok.y)
buttonfeld_abbruch  = neuesGrafikfeld(Ginfo.x+Ginfo.b\2-button_abbruch.x\2, Ginfo.y+Ginfo.h-40, _
                                      button_abbruch.x, button_abbruch.y)
buttonfeld_abbruch2 = neuesGrafikfeld(Ginfo.x+Ginfo.b-button_abbruch.x-50, Ginfo.y+Ginfo.h-40, _
                                      button_abbruch.x, button_abbruch.y)
buttonfeld_minus    = neuesGrafikfeld(Ginfo.x+70, Ginfo.y+300, button_minus.x, button_minus.y)
buttonfeld_plus     = neuesGrafikfeld(Ginfo.x+Ginfo.b-90, Ginfo.y+300, button_plus.x, button_plus.y)
buttonfeld_wert     = neuesGrafikfeld((buttonfeld_plus.x+buttonfeld_minus.x)\2-30, buttonfeld_plus.y+6, 80, 8)

text = ""

sub destruct destructor
  imagedestroy menuleiste.grafik
  imagedestroy wuerfelseite.grafik
  imagedestroy wuerfelauge.grafik
  imagedestroy button_ja.grafik
  imagedestroy button_nein.grafik
  imagedestroy button_ok.grafik
  imagedestroy button_abbruch.grafik
  imagedestroy button_ende.grafik
  imagedestroy button_plus.grafik
  imagedestroy button_minus.grafik
  imagedestroy button_farbe.grafik
  for i=0 to 100
    imagedestroy feld(i).icon.grafik
  next
end sub

sub ladeTexte(byval sprache as string)
  ' Sprachdatei laden:
  dim f as ubyte = freefile, zeile as string
  open "data/lang." & sprache & ".txt" for input as f
  do while not eof(f)
    line input #f, zeile
    if left(zeile,  9) = "optTitle="         then MSG_optTitle         = mid(zeile, 10)
    if left(zeile, 12) = "optLanguage="      then MSG_optLanguage      = mid(zeile, 13)
    if left(zeile,  9) = "optBoard="         then MSG_optBoard         = mid(zeile, 10)
    if left(zeile, 14) = "optPlayerName="    then MSG_optPlayerName    = mid(zeile, 15)
    if left(zeile,  8) = "optNone="          then MSG_optType(0)       = mid(zeile,  9)
    if left(zeile,  9) = "optHuman="         then MSG_optType(1)       = mid(zeile, 10)
    if left(zeile,  7) = "optAI1="           then MSG_optType(2)       = mid(zeile,  8)
    if left(zeile,  7) = "optAI2="           then MSG_optType(3)       = mid(zeile,  8)
    if left(zeile,  7) = "optAI3="           then MSG_optType(4)       = mid(zeile,  8)
    if left(zeile,  9) = "optColor="         then MSG_optColor         = mid(zeile, 10)
    if left(zeile,  7) = "optAim="           then MSG_optAim           = mid(zeile,  8)
    if left(zeile,  8) = "optAim1="          then MSG_optAim1          = mid(zeile,  9)
    if left(zeile,  8) = "optAim2="          then MSG_optAim2          = mid(zeile,  9)
    if left(zeile,  8) = "optAim3="          then MSG_optAim3          = mid(zeile,  9)
    if left(zeile, 11) = "askNewGame="       then MSG_askNewGame       = mid(zeile, 12)
    if left(zeile, 10) = "errorFile="        then MSG_errorFile        = mid(zeile, 11)
    if left(zeile, 12) = "errorGroups="      then MSG_errorGroups      = mid(zeile, 13)
    if left(zeile, 12) = "errorFields="      then MSG_errorFile        = mid(zeile, 13)
    if left(zeile, 11) = "errorDecks="       then MSG_errorDecks       = mid(zeile, 12)
    if left(zeile, 11) = "errorCards="       then MSG_errorCards       = mid(zeile, 12)
    if left(zeile, 12) = "errorUnused="      then MSG_errorUnused      = mid(zeile, 13)
    if left(zeile, 12) = "errorIgnore="      then MSG_errorIgnore      = mid(zeile, 13)
    if left(zeile, 15) = "errorAddFields="   then MSG_errorAddFields   = mid(zeile, 16)
    if left(zeile, 13) = "errorVersion="     then MSG_errorVersion     = mid(zeile, 14)
    if left(zeile, 10) = "errorPart="        then MSG_errorPart        = mid(zeile, 11)
    if left(zeile,  8) = "noteLog="          then MSG_noteLog          = mid(zeile,  9)
    if left(zeile, 11) = "noteAuthor="       then MSG_noteAuthor       = mid(zeile, 12)
    if left(zeile, 10) = "noteStart="        then MSG_noteStart        = mid(zeile, 11)
    if left(zeile,  6) = "house="            then MSG_house            = mid(zeile,  7)
    if left(zeile,  7) = "houses="           then MSG_houses           = mid(zeile,  8)
    if left(zeile,  6) = "hotel="            then MSG_hotel            = mid(zeile,  7)
    if left(zeile,  7) = "hotels="           then MSG_hotels           = mid(zeile,  8)
    if left(zeile,  7) = "street="           then MSG_street           = mid(zeile,  8)
    if left(zeile,  8) = "streets="          then MSG_streets          = mid(zeile,  9)
    if left(zeile,  5) = "jail="             then MSG_jail             = mid(zeile,  6)
    if left(zeile,  6) = "price="            then MSG_price            = mid(zeile,  7)
    if left(zeile,  8) = "minprop="          then MSG_minprop          = mid(zeile,  9)
    if left(zeile, 11) = "houseprice="       then MSG_houseprice       = mid(zeile, 12)
    if left(zeile,  5) = "rent="             then MSG_rent             = mid(zeile,  6)
    if left(zeile,  5) = "name="             then MSG_name             = mid(zeile,  6)
    if left(zeile,  5) = "cash="             then MSG_cash             = mid(zeile,  6)
    if left(zeile,  8) = "capital="          then MSG_capital          = mid(zeile,  9)
    if left(zeile,  9) = "currency="         then MSG_currency         = mid(zeile, 10)
    if left(zeile,  5) = "turn="             then MSG_turn             = mid(zeile,  6)
    if left(zeile,  5) = "info="             then MSG_info             = mid(zeile,  6)
    if left(zeile,  9) = "position="         then MSG_position         = mid(zeile, 10)
    if left(zeile,  7) = "inJail="           then MSG_inJail           = mid(zeile,  8)
    if left(zeile,  6) = "score="            then MSG_score            = mid(zeile,  7)
    if left(zeile,  7) = "double="           then MSG_double           = mid(zeile,  8)
    if left(zeile, 13) = "threeDoubles="     then MSG_threeDoubles     = mid(zeile, 14)
    if left(zeile, 10) = "outOfJail="        then MSG_outOfJail        = mid(zeile, 11)
    if left(zeile, 10) = "onceAgain="        then MSG_onceAgain        = mid(zeile, 11)
    if left(zeile,  9) = "payJail1="         then MSG_payJail1         = mid(zeile, 10)
    if left(zeile,  9) = "payJail2="         then MSG_payJail2         = mid(zeile, 10)
    if left(zeile,  8) = "noMoney="          then MSG_noMoney          = mid(zeile,  9)
    if left(zeile,  9) = "withdraw="         then MSG_withdraw         = mid(zeile, 10)
    if left(zeile,  9) = "payDept1="         then MSG_payDept1         = mid(zeile, 10)
    if left(zeile,  9) = "payDept2="         then MSG_payDept2         = mid(zeile, 10)
    if left(zeile,  6) = "money="            then MSG_money            = mid(zeile,  7)
    if left(zeile,  9) = "drawCard="         then MSG_drawCard         = mid(zeile, 10)
    if left(zeile,  9) = "taxFixed="         then MSG_taxFixed         = mid(zeile, 10)
    if left(zeile,  9) = "getFixed="         then MSG_getFixed         = mid(zeile, 10)
    if left(zeile, 11) = "taxPercent="       then MSG_taxPercent       = mid(zeile, 12)
    if left(zeile, 11) = "getPercent="       then MSG_getPercent       = mid(zeile, 12)
    if left(zeile,  9) = "taxMixed="         then MSG_taxMixed         = mid(zeile, 10)
    if left(zeile,  9) = "getMixed="         then MSG_getMixed         = mid(zeile, 10)
    if left(zeile, 11) = "taxCollect="       then MSG_taxCollect       = mid(zeile, 12)
    if left(zeile,  7) = "getPay="           then MSG_getPay           = mid(zeile,  8)
    if left(zeile, 10) = "noCollect="        then MSG_noCollect        = mid(zeile, 11)
    if left(zeile,  7) = "passGo="           then MSG_passGo           = mid(zeile,  8)
    if left(zeile, 10) = "collectGo="        then MSG_collectGo        = mid(zeile, 11)
    if left(zeile,  6) = "payGo="            then MSG_payGo            = mid(zeile,  7)
    if left(zeile,  8) = "infoGo1="          then MSG_infoGo1          = mid(zeile,  9)
    if left(zeile,  8) = "infoGo2="          then MSG_infoGo2          = mid(zeile,  9)
    if left(zeile, 12) = "collectCard="      then MSG_collectCard      = mid(zeile, 13)
    if left(zeile,  8) = "payCard="          then MSG_payCard          = mid(zeile,  9)
    if left(zeile, 11) = "reachField="       then MSG_reachField       = mid(zeile, 12)
    if left(zeile, 10) = "justVisit="        then MSG_justVisit        = mid(zeile, 11)
    if left(zeile, 13) = "collectField="     then MSG_collectField     = mid(zeile, 14)
    if left(zeile,  8) = "payRent="          then MSG_payRent          = mid(zeile,  9)
    if left(zeile,  7) = "noRent="           then MSG_noRent           = mid(zeile,  8)
    if left(zeile,  8) = "forSale="          then MSG_forSale          = mid(zeile,  9)
    if left(zeile,  7) = "askBuy="           then MSG_askBuy           = mid(zeile,  8)
    if left(zeile,  4) = "buy="              then MSG_buy              = mid(zeile,  5)
    if left(zeile,  7) = "notBuy="           then MSG_notBuy           = mid(zeile,  8)
    if left(zeile, 11) = "clickToBuy="       then MSG_clickToBuy       = mid(zeile, 12)
    if left(zeile, 12) = "clickToSell="      then MSG_clickToSell      = mid(zeile, 13)
    if left(zeile,  9) = "pressESC="         then MSG_pressESC         = mid(zeile, 10)
    if left(zeile,  7) = "rounds="           then MSG_rounds           = mid(zeile,  8)
    if left(zeile,  4) = "win="              then MSG_win              = mid(zeile,  5)
    if left(zeile,  9) = "gameOver="         then MSG_gameOver         = mid(zeile, 10)
    if left(zeile,  6) = "trade="            then MSG_trade            = mid(zeile,  7)
    if left(zeile, 17) = "tradeInstruction=" then MSG_tradeInstruction = mid(zeile, 18)
    if left(zeile, 11) = "tradeMoney="       then MSG_tradeMoney       = mid(zeile, 12)
    if left(zeile,  8) = "tradeOk="          then MSG_tradeOK          = mid(zeile,  9)
    if left(zeile, 14) = "tradeMakeDeal="    then MSG_tradeMakeDeal    = mid(zeile, 15)
    if left(zeile, 13) = "tradeBadDeal="     then MSG_tradeBadDeal     = mid(zeile, 14)
    if left(zeile, 12) = "tradeNoDeal="      then MSG_tradeNoDeal      = mid(zeile, 13)
    if left(zeile,  7) = "credit="           then MSG_credit           = mid(zeile,  8)
    if left(zeile, 11) = "humanBroke="       then MSG_humanBroke       = mid(zeile, 12)
    if left(zeile,  8) = "aiBroke="          then MSG_aiBroke          = mid(zeile,  9)
    if left(zeile,  6) = "aiBuy="            then MSG_aiBuy            = mid(zeile,  7)
    if left(zeile,  7) = "aiSell="           then MSG_aiSell           = mid(zeile,  8)
    if left(zeile, 11) = "aiMortgage="       then MSG_aiMortgage       = mid(zeile, 12)
    if left(zeile, 10) = "aiWipeOff="        then MSG_aiWipeOff        = mid(zeile, 11)
  loop
  close #f
  gefaengnis = MSG_jail
end sub

function neu(byval dateiname as string) as ubyte
  ' Liest ein Spielfeld ein und initialisiert es.
  '########## EINLESEN DER SPIELREGELN ##########
  for i=0 to 100
    if feld(i).icon.grafik <> 0 then
      imagedestroy feld(i).icon.grafik
      feld(i).icon.grafik = 0
    end if
  next
  dim as string zeile, lz, level0, level1, temp
  dim as ushort zeilennr, kommentar
  dim as ubyte fehler, minbesitz = 100
  open "game/" & dateiname for input as #1
  open "status.log" for output as #2
  erase gruppe, feld, kartenstapel, karte, AnzahlKarten
  AnzahlGruppen = 0
  AnzahlFelder = 0
  AnzahlStapel = 0
  MaxHauszahl = 5
  MaxKredite = 3
  Jail = 0
  curunit = 10
  spielname = ""
  spielbeschreibung = ""
  spielautor = ""
  spielversion = ""
  spielkredit = 0
  spielzins = 0
  zeile = ""
  zeilennr = 0
  do while not eof(1)
    line input #1, zeile
    zeilennr += 1
    zeile = trim(zeile)
    if zeile = "" or left(zeile, 1) = "#" then continue do
    lz = lcase(zeile)

    if lz="<general>" or lz="<board>" or lz="<estategroups>" or lz="<estates>" or lz="<cards>" then
      level0 = lz
      level1 = ""
      continue do
    end if
    select case level0

    case "<general>"  ' generelle Einstellungen
      if left(lz, 16) = "program_version=" then
        if VERSION < mid(zeile, 17) then
          print #2, msg(MSG_errorVersion, mid(zeile, 17), VERSION)
          fehler = fehler or 2
        end if
        continue do
      end if
      if left(lz, 5) = "name=" then
        spielname = mid(zeile, 6)
        continue do
      end if
      if left(lz, 8) = "version=" then
        spielversion = mid(zeile, 9)
        continue do
      end if
      if left(lz, 8) = "authors=" then
        spielautor = mid(zeile,9)
        continue do
      end if
      if left(lz, 12) = "description=" then
        spielbeschreibung = mid(zeile, 13)
        continue do
      end if
      if left(lz, 11) = "minplayers=" then
        spielmin = val(mid(zeile, 12))
        continue do
      end if
      if left(lz, 11) = "maxplayers=" then
        spielmax = val(mid(zeile, 12))
        continue do
      end if
      if left(lz, 7) = "houses=" then
        spielhaus = val(mid(zeile, 8))
        continue do
      end if
      if left(lz, 7) = "hotels=" then
        spielhotel = val(mid(zeile, 8))
        continue do
      end if
      if left(lz, 11) = "startmoney=" then
        spielgeld = val(mid(zeile, 12))
        continue do
      end if
      if left(lz, 10) = "maxhouses=" then
        MaxHauszahl = val(mid(zeile, 11))
        continue do
      end if
      if left(lz, 8) = "minprop=" then
        minbesitz = val(mid(zeile, 9))
        continue do
      end if
      if left(lz, 7) = "credit=" then
        spielkredit = val(mid(zeile, 8))
        continue do
      end if
      if left(lz, 9) = "interest=" then
        spielzins = val(mid(zeile, 10))
        continue do
      end if
      if left(lz, 11) = "maxcredits=" then
        MaxKredite = val(mid(zeile, 11))
        continue do
      end if
      if left(lz, 13) = "currencyunit=" then
        curunit = val(mid(zeile, 14))
        continue do
      end if

    case "<board>"  ' allgemeine Feldoptionen
      if left(lz, 3) = "go=" then
        spielstart = val(mid(zeile, 4))+1
        continue do
      end if
      if left(lz, 9) = "bgcolor=#" then
       spielhgfarbe = mid(zeile, 10)
        continue do
      end if

    case "<estategroups>"  ' Strassengruppen
      if left(zeile,1) = "[" and right(zeile,1) = "]" then
        if AnzahlGruppen > 99 then
          print #2, MSG_errorGroups
          fehler = 4: exit do
        end if
        AnzahlGruppen += 1
        level1 = mid(zeile, 2, len(zeile)-2)
        gruppe(AnzahlGruppen).name = level1
        continue do
      end if
      if level1 = "" then
        print #2, msg(MSG_errorIgnore, str(zeilennr), zeile)
        fehler = fehler or 2
        continue do
      end if
      if left(lz, 7) = "color=#" then
        gruppe(AnzahlGruppen).farbe = mid(zeile, 8)
        continue do
      end if
      if left(lz, 9) = "bgcolor=#" then
        gruppe(AnzahlGruppen).hgfarbe = mid(zeile, 10)
        continue do
      end if
      if left(lz, 6) = "price=" then
        gruppe(AnzahlGruppen).preis = val(mid(zeile, 7))
        continue do
      end if
      if left(lz, 11) = "houseprice=" then
        gruppe(AnzahlGruppen).hauspreis = val(mid(zeile, 12))
        continue do
      end if
      if left(lz, 4) = "rent" and mid(lz, 6, 1) = "=" then
        gruppe(AnzahlGruppen).miete(val(mid(lz, 5, 1))) = val(mid(zeile, 7))
        continue do
      end if
      if left(lz, 4) = "rent" and mid(lz, 7, 1) = "=" then
        gruppe(AnzahlGruppen).miete(val(mid(lz, 5, 2))) = val(mid(zeile, 8))
        continue do
      end if
      if left(lz, 9) = "rentmath=" then
        gruppe(AnzahlGruppen).rentmath = mid(zeile, 10)
        continue do
      end if
      if left(lz, 8) = "minprop=" then
        gruppe(AnzahlGruppen).minbesitz = val(mid(zeile, 9))
        continue do
      end if

    case "<estates>" ' Felder
      if left(lz, 1) = "[" and right(lz, 1) = "]" then
        if AnzahlFelder > 99 then
          print #2, MSG_errorFields
          fehler = 4: exit do
        end if
        AnzahlFelder += 1
        level1 = mid(zeile, 2, len(zeile)-2)
        with feld(AnzahlFelder)
          .nr = AnzahlFelder
          .name = level1
          .farbe = spielfarbe
          .hgfarbe = spielhgfarbe
        end with
        continue do
      end if
      if level1 = "" then
        print #2, msg(MSG_errorIgnore, str(zeilennr), zeile)
        fehler = fehler or 2
        continue do
      end if
      if left(lz, 5) = "icon=" then
        temp = mid(zeile, 6)
        if right(temp, 4) = ".png" then temp = left(temp, len(temp)-4) & ".bmp"
        bildladen(temp, feld(AnzahlFelder).icon)
        continue do
      end if
      if left(lz, 7) = "color=#" then
        feld(AnzahlFelder).farbe = mid(zeile, 8)
        continue do
      end if
      if left(lz, 9) = "bgcolor=#" then
        feld(AnzahlFelder).hgfarbe = mid(zeile, 10)
        continue do
      end if
      if left(lz, 10) = "passmoney=" then
        feld(AnzahlFelder).einkommen = val(mid(zeile, 11))
        continue do
      end if
      if left(lz, 6) = "group=" then
        if feld(AnzahlFelder).art = 0 then feld(AnzahlFelder).art = 1
        feld(AnzahlFelder).gruppenname = mid(zeile, 7)
        continue do
      end if
      if left(lz, 11) = "houseprice=" then
        feld(AnzahlFelder).hauspreis = val(mid(zeile, 12))
        continue do
      end if
      if left(lz, 6) = "price=" then
        feld(AnzahlFelder).preis = val(mid(zeile, 7))
        continue do
      end if
      if left(lz, 4) = "rent" and mid(lz, 6, 1) = "=" then
        feld(AnzahlFelder).miete(val(mid(lz, 5, 1))) = val(mid(zeile, 7))
        continue do
      end if
      if left(lz, 4) = "rent" and mid(lz, 7, 1) = "=" then
        feld(AnzahlFelder).miete(val(mid(lz, 5, 2))) = val(mid(zeile, 8))
        continue do
      end if
      if left(lz, 9) = "rentmath=" then
        feld(AnzahlFelder).rentmath = mid(zeile, 10)
        continue do
      end if
      if left(lz, 9) = "takecard=" then
        feld(AnzahlFelder).art = 2
        feld(AnzahlFelder).gruppenname = mid(zeile, 10)
        continue do
      end if
      if left(lz, 10) = "paytarget=" then
        feld(AnzahlFelder).geldsammelpunkt = val(mid(zeile, 11)) + 1
        continue do
      end if
      if left(lz, 4) = "tax=" then
        feld(AnzahlFelder).art = 3
        feld(AnzahlFelder).preis = val(mid(zeile, 5))
        continue do
      end if
      if left(lz, 14) = "taxpercentage=" then
        feld(AnzahlFelder).art = 3
        feld(AnzahlFelder).hauspreis = val(mid(zeile, 15))
        continue do
      end if
      if left(lz, 5) = "jail=" then
        feld(AnzahlFelder).art = 255
        gefaengnis = feld(AnzahlFelder).name
        Jail = AnzahlFelder
        continue do
      end if
      if left(lz, 10) = "payamount=" then
        feld(AnzahlFelder).preis = val(mid(zeile, 11))
        continue do
      end if
      if left(lz, 7) = "tojail=" then
        feld(AnzahlFelder).gehezu = 255
        continue do
      end if
      if left(lz, 17) = "advancetoifowned=" then
        feld(AnzahlFelder).gehezueigen = val(mid(zeile, 18)) + 1
        continue do
      end if
      if lz = "freeparking=1" then
        feld(AnzahlFelder).art or= 4
        continue do
      end if

    case "<cards>"  ' Karten
      if left(lz, 10) = "groupname=" then
        level1 = mid(zeile,11)
        if AnzahlStapel > 8 then
          print #2, MSG_errorDecks
          fehler = 4: exit do
        end if
        AnzahlStapel += 1
        kartenstapel(AnzahlStapel).name = level1
        continue do
      end if
      if level1 = "" then
        print #2, msg(MSG_errorIgnore, str(zeilennr), zeile)
        fehler = fehler or 2
        continue do
      end if
      if left(lz, 7) = "color=#" then
        kartenstapel(AnzahlStapel).farbe = mid(zeile, 8)
        continue do
      end if
      if left(lz, 9) = "bgcolor=#" then
        kartenstapel(AnzahlStapel).hgfarbe = mid(zeile, 10)
        continue do
      end if
      if left(zeile, 1) = "[" then
        if AnzahlKarten(AnzahlStapel) > 254 then
          print #2, msg(MSG_errorCards, kartenstapel(AnzahlStapel).name)
          fehler = 2: exit do
        end if
        AnzahlKarten(AnzahlStapel) += 1
        lz = mid(zeile,2)
        do while right(zeile,1) <> "]" and not eof(1)
          line input #1, zeile
          lz &= " " & trim(zeile)
          zeilennr += 1
        loop
        karte(AnzahlStapel, AnzahlKarten(AnzahlStapel)).name = left(lz, len(lz)-1)
        continue do
      end if
      if left(lz, 4) = "pay=" then
        karte(AnzahlStapel, AnzahlKarten(AnzahlStapel)).zahle = val(mid(zeile, 5))
        continue do
      end if
      if left(lz, 8) = "payeach=" then
        karte(AnzahlStapel, AnzahlKarten(AnzahlStapel)).zahleallen = val(mid(zeile, 9))
        print #2, karte(AnzahlStapel, AnzahlKarten(AnzahlStapel)).zahleallen
        continue do
      end if
      if left(lz, 9) = "payhouse=" then
        karte(AnzahlStapel, AnzahlKarten(AnzahlStapel)).zahlehaus = val(mid(zeile, 10))
        continue do
      end if
      if left(lz, 9) = "payhotel=" then
        karte(AnzahlStapel, AnzahlKarten(AnzahlStapel)).zahlehotel = val(mid(zeile, 10))
        continue do
      end if
      if left(lz, 8) = "advance=" then
        karte(AnzahlStapel, AnzahlKarten(AnzahlStapel)).gehe = val(mid(zeile, 9))
        continue do
      end if
      if left(lz, 10) = "advanceto=" then
        karte(AnzahlStapel, AnzahlKarten(AnzahlStapel)).gehezufeld = val(mid(zeile, 11)) + 1
        continue do
      end if
      if left(lz, 7) = "tojail=" then
        karte(AnzahlStapel, AnzahlKarten(AnzahlStapel)).gehezufeld = 255
        continue do
      end if
      if left(lz, 16) = "advancetonextof=" then
        karte(AnzahlStapel, AnzahlKarten(AnzahlStapel)).gehezugruppe = mid(zeile, 17)
        continue do
      end if
      if left(lz, 10) = "outofjail=" then
        karte(AnzahlStapel, AnzahlKarten(AnzahlStapel)).befreiung = val(mid(zeile, 11))
        continue do
      end if
      if left(lz, 11) = "canbeowned=" then
        karte(AnzahlStapel, AnzahlKarten(AnzahlStapel)).behaltbar = val(mid(zeile, 12))
        continue do
      end if
      if left(lz, 9) = "rentmath=" then
        karte(AnzahlStapel, AnzahlKarten(AnzahlStapel)).rentmath = mid(zeile, 10)
        continue do
      end if
    end select
    print #2, msg(MSG_errorUnused, str(zeilennr), zeile)
    fehler = fehler or 1
  loop
  close 1

  if AnzahlFelder < 20 or (AnzahlFelder mod 4) <> 0 then
    print #2, MSG_errorAddFields
    fehler = fehler or 2
  end if
  if AnzahlFelder < 20 then AnzahlFelder = 20
  AnzahlFelder += 3 - ((AnzahlFelder-1) mod 4)
  dim as ushort feldbreite = int(Gspielfeld.b / (AnzahlFelder/4+2)) * (AnzahlFelder/4+2)
  dim as ushort feldhoehe = int(Gspielfeld.h / (AnzahlFelder/4+2)) * (AnzahlFelder/4+2)
  dim as ushort normb = feldbreite / (AnzahlFelder/4 + 2), normh = feldhoehe / (AnzahlFelder/4 + 2)
  for i= 1 to AnzahlFelder
    with feld(i)
      if i <= AnzahlFelder/4 then
        .position.b = int(normb)
        .position.h = int(normh*3/2)
        .position.x = int((AnzahlFelder/4 - i + 1.5)*normb)
        .position.y = feldhoehe - .position.h
        if i = 1 then .position.b = int(3/2*normb)
        .statusleiste.x = .position.x
        .statusleiste.y = .position.y
        .statusleiste.b = .position.b
        .statusleiste.h = .position.h/4+3
      elseif i <= AnzahlFelder/2 then
        .position.b = int(normb*3/2)
        .position.h = int(normh)
        .position.x = 0
        .position.y = int((AnzahlFelder/2 - i + 1.5)*normh)
        if i = AnzahlFelder/4 + 1 then .position.h=int(3/2*normh)
        .statusleiste.x = .position.x+normb*9/8-2
        .statusleiste.y = .position.y
        .statusleiste.b = .position.b/4+2
        .statusleiste.h = .position.h
      elseif i <= AnzahlFelder*3/4 then
        .position.b = int(normb)
        .position.h = int(normh*3/2)
        .position.x = int((i - AnzahlFelder/2 - .5)*normb)
        .position.y = 0
        if i = AnzahlFelder/2 + 1 then .position.b=int(3/2*normb): .position.x=0
        .statusleiste.x = .position.x
        .statusleiste.y = .position.y+normh*9/8-3
        .statusleiste.b = .position.b
        .statusleiste.h = .position.h/4+3
      else
        .position.b = int(normb*3/2)
        .position.h = int(normh)
        .position.x = feldbreite - .position.b
        .position.y = int((i - AnzahlFelder*3/4 - .5)*normh)
        if i = AnzahlFelder*3/4 + 1 then .position.h=int(3/2*normh): .position.y=0
        .statusleiste.x = .position.x
        .statusleiste.y = .position.y
        .statusleiste.b = .position.b/4+3
        .statusleiste.h = .position.h
      end if

      if .art = 1 then
        for k = 1 to AnzahlGruppen
          if gruppe(k).name = .gruppenname then
            .gruppe = k
            .hgfarbe = gruppe(k).hgfarbe
            .farbe = gruppe(k).farbe
            if .rentmath = "" then .rentmath = gruppe(k).rentmath
            for l as ubyte = 0 to 99
              if gruppe(k).miete(l) = 0 then exit for
              if .miete(l) = 0 then .miete(l) = gruppe(k).miete(l)
            next
            if .preis = 0 then .preis = gruppe(k).preis
            if .hauspreis = 0 then .hauspreis = gruppe(k).hauspreis
            if gruppe(k).minbesitz = 0 then gruppe(k).minbesitz = minbesitz
            gruppe(.gruppe).grundstuecke &= chr(i)
          end if
        next
      end if
      if .art = 2 then
        for k = 1 to AnzahlStapel
          if kartenstapel(k).name = .gruppenname then .gruppe = k
        next
      end if
      if .hgfarbe = "" then .hgfarbe = spielhgfarbe
      if .farbe = "" then .farbe = .hgfarbe
      .farb_rgb = val("&H"&.farbe)
      .hg_rgb = val("&H"&.hgfarbe)
    end with
  next
  ' Ereigniskarten mischen
  for i = 1 to AnzahlStapel
    dim as ubyte anz = AnzahlKarten(i)
    kartenstapel(i).position = 0
    for k = 1 to anz
      for j = k+1 to anz
        if int(rnd*(j+1-k)) = 0 then swap karte(i, k), karte(i, j)
      next
    next
  next
  close 2
  ' Berechnung des Mietniveaus (Orientierung fuer AI)
  dim mietsumme as uinteger = 0, grupp as ubyte
  for i as ubyte = 1 to AnzahlFelder
    if feld(i).art = 1 then
      AIfeldzahl += 1
      grupp = len(gruppe(feld(i).gruppe).grundstuecke)
      mietsumme += mietberechnung(feld(i), 12, grupp, grupp, MaxHauszahl)
    end if
  next
  AImietniveau = mietsumme \ AIfeldzahl
  return fehler
end function

function neuesGrafikfeld(byval x as ushort, byval y as ushort, byval b as ushort, byval h as ushort) as TypGrafikfeld
  ' Initialisert ein neues Grafikfeld. x,y,b,h: Koordinaten des Feldes
  dim as TypGrafikfeld ret
  ret.x = x
  ret.y = y
  ret.b = b
  ret.h = h
  return ret
end function

sub optionen(byval opt as ubyte)
  ' Spieleinstellungen
  ' opt= 1: Starteinstellung; 2: Einstellung waehrend des Spiels
  cls
  redim as string sprachen(0), spielfelder(0)
  dim as string zeile, lz, ziel(5), ssprache, sbrett
  dim as integer AnzahlSprachen, AnzahlSpielfelder, mx, my, mb, m2x, m2y
  dim as TypGrafikfeld ms, ps, ts, mf, pf, tf, tb, mz, pz, tz, hh, hs, hf, hz, hp, ok, nd
  dim as TypGrafikfeld m(1 to 20), p(1 to 20), tp(1 to 20), f(1 to 20)
  dim as TypGrafikfeld farbplus(1 to 20), farbminus(1 to 20)
  dim as ubyte datei = freefile, fehler, r, g, b
  ' Standardeinstellungen (falls keine Datei vorhanden)
  if opt = 1 then
    erase spieler
    AnzahlSpieler = 0
    spieler( 1).name = "Anna":    spieler( 1).farbe = rgb(255,   0,   0)
    spieler( 2).name = "Berta":   spieler( 2).farbe = rgb(  0, 255,   0)
    spieler( 3).name = "Charly":  spieler( 3).farbe = rgb(  0,   0, 255)
    spieler( 4).name = "Doris":   spieler( 4).farbe = rgb(255,   0, 255)
    spieler( 5).name = "Erwin":   spieler( 5).farbe = rgb(255, 255,   0)
    spieler( 6).name = "Fritz":   spieler( 6).farbe = rgb(  0, 255, 255)
    spieler( 7).name = "Gustav":  spieler( 7).farbe = rgb(127,   0, 255)
    spieler( 8).name = "Heike":   spieler( 8).farbe = rgb(255, 127,   0)
    spieler( 9).name = "Igor":    spieler( 9).farbe = rgb(  0, 255, 127)
    spieler(10).name = "Jasmin":  spieler(10).farbe = rgb(127, 127,   0)
    spieler(11).name = "Klaus":   spieler(11).farbe = rgb(127,   0, 127)
    spieler(12).name = "Lisa":    spieler(12).farbe = rgb(  0, 127, 127)
    spieler(13).name = "Maria":   spieler(13).farbe = rgb(127, 255, 255)
    spieler(14).name = "Norbert": spieler(14).farbe = rgb(255, 127, 255)
    spieler(15).name = "Ottokar": spieler(15).farbe = rgb(255, 255, 127)
    spieler(16).name = "Petra":   spieler(16).farbe = rgb(255, 127, 127)
    spieler(17).name = "Quirin":  spieler(17).farbe = rgb(127, 255, 127)
    spieler(18).name = "Rita":    spieler(18).farbe = rgb(127, 127, 255)
    spieler(19).name = "Sarah":   spieler(19).farbe = rgb(255,   0, 127)
    spieler(20).name = "Thomas":  spieler(20).farbe = rgb(127, 255,   0)
  end if
  ' Standardeinstellungen laden (wenn vorhanden)
  if opt = 1 then
    open "data/monopolz.ini" for input as datei
    do while not eof(datei)
      line input #datei, zeile
      zeile = trim(zeile)
      lz = lcase(zeile)
      if left(lz, 9) = "language=" then ssprache = mid(zeile, 10)
      if left(lz, 6) = "board=" then sbrett = mid(zeile, 7)
      if left(lz, 4) = "aim=" then spielziel = val(mid(zeile, 5))
      for i as ubyte = 1 to 20
        if left(lz, 6) = "name" & i & "=" or left(lz, 7) = "name" & i & "=" then
         spieler(i).name = mid(zeile, instr(zeile, "=") + 1)
        end if
        if left(lz, 7) = "color" & i & "=" or left(lz, 8) = "name" & i & "=" then
         spieler(i).farbe = val(mid(zeile, instr(zeile, "=") + 1))
        end if
        if left(lz, 6) = "type" & i & "=" or left(lz, 7) = "type" & i & "=" then
         spieler(i).typ = val(mid(zeile, instr(zeile, "=") + 1))
         if spieler(i).typ <> 0 then AnzahlSpieler += 1
        end if
      next
    loop
    close datei
  end if
  ' Sprachen laden
  sprachen(0) = dir("data/lang.*.txt")
  if sprachen(0) = "" then
    print "FEHLER: ES EXISTIEREN KEINE SPRACHDATEIEN!"
    getkey
    ende = -1 : exit sub
  end if
  do
    AnzahlSprachen += 1
    redim preserve sprachen(AnzahlSprachen)
    sprachen(AnzahlSprachen) = dir()
    if opt = 1 and sprachen(Anzahlsprachen) = "lang." & ssprache & ".txt" then sprache = AnzahlSprachen
  loop until sprachen(AnzahlSprachen) = ""
  ' Spielfelder laden
  spielfelder(0) = dir("game/*.conf")
  if spielfelder(0) = "" then
    print "FEHLER: ES EXISTIEREN KEINE SPIELFELD-DATEIEN!"
    getkey
    ende = -1 : exit sub
  end if
  ladeTexte mid(sprachen(sprache), 6, len(sprachen(sprache))-9)
  do
    AnzahlSpielfelder += 1
    redim preserve spielfelder(AnzahlSpielfelder)
    spielfelder(AnzahlSpielfelder) = dir()
    if opt = 1 and spielfelder(AnzahlSpielfelder) = sbrett & ".conf" then spielfeld = AnzahlSpielfelder
  loop until spielfelder(AnzahlSpielfelder) = ""

  ' Spielfelddaten laden
  dim as TypSpielfeld felddaten(AnzahlSpielfelder - 1)
  for i as ubyte = 0 to AnzahlSpielfelder -1
    with felddaten(i)
      open "game/" & spielfelder(i) for input as datei
      do while not eof(datei)
        line input #datei, zeile
        zeile = trim(zeile)
        lz = lcase(zeile)
        if lz="<board>" or lz="<estategroups>" or lz="<estates>" or lz="<cards>" then exit do
        if left(lz, 16) = "program_version=" then .programmversion = mid(zeile, 17)
        if left(lz,  5) = "name=" then .name = mid(zeile, 6)
        if left(lz,  8) = "version=" then .version = mid(zeile, 9)
        if left(lz,  8) = "authors=" then .autor = mid(zeile,9)
        if left(lz, 12) = "description=" then .beschreibung = mid(zeile, 13)
        if left(lz, 11) = "startmoney=" then .startgeld = val(mid(zeile, 12))
        if left(lz, 11) = "minplayers=" then .min = val(mid(zeile, 12))
        if left(lz, 11) = "maxplayers=" then .max = val(mid(zeile, 12))
      loop
    end with
    close datei
  next
  ziel(0) = MSG_optAim1
  ziel(1) = msg(MSG_optAim2, 3*felddaten(spielfeld).startgeld & MSG_currency)
  ziel(2) = msg(MSG_optAim2, 5*felddaten(spielfeld).startgeld & MSG_currency)
  ziel(3) = msg(MSG_optAim3, str(100))
  ziel(4) = msg(MSG_optAim3, str(200))

  ' grafische Ausgabe
  cls
  windowtitle "MonopolZ - " & MSG_optTitle
  hh = neuesGrafikfeld(100, 40, 600, 10)  ' Hauptueberschrift
  hs = neuesGrafikfeld(50, 80, 150, 10)   ' Sprache
  hf = neuesGrafikfeld(290, 80, 150, 10)  ' Feld
  hz = neuesGrafikfeld(530, 80, 150, 10)  ' Ziel
  hp = neuesGrafikfeld(50, 150, 150, 10)  ' Players
  ok = neuesGrafikfeld(380-button_ok.x, 550, button_ok.x, button_ok.y)
  nd = neuesGrafikfeld(420+button_ende.x, 550, button_ende.x, button_ende.y)
  ms = neuesGrafikfeld(50, 100, button_minus.x, button_minus.y)
  ps = neuesGrafikfeld(200, 100, button_plus.x, button_plus.y)
  ts = neuesGrafikfeld(50+button_minus.x, 100, 150-button_minus.x, button_minus.y)
  mf = neuesGrafikfeld(290, 100, button_minus.x, button_minus.y)
  pf = neuesGrafikfeld(440, 100, button_plus.x, button_plus.y)
  tf = neuesGrafikfeld(290+button_minus.x, 100, 150-button_minus.x, button_minus.y)
  mz = neuesGrafikfeld(530, 100, button_minus.x, button_minus.y)
  pz = neuesGrafikfeld(730, 100, button_plus.x, button_plus.y)
  tz = neuesGrafikfeld(530+button_minus.x, 100, 200-button_minus.x, button_minus.y)
  tb = neuesGrafikfeld(50, 150, 700-button_plus.x, 10)
  put (ms.x, ms.y), button_minus.grafik, pset
  put (ps.x, ps.y), button_plus.grafik, pset
  put (mf.x, mf.y), button_minus.grafik, pset
  put (pf.x, pf.y), button_plus.grafik, pset
  put (mz.x, mz.y), button_minus.grafik, pset
  put (pz.x, pz.y), button_plus.grafik, pset
  put (ok.x, ok.y), button_ok.grafik, pset
  put (nd.x, nd.y), button_ende.grafik, pset
  textausgabe hh, MSG_optTitle
  draw string (hs.x, hs.y), MSG_optLanguage
  draw string (hf.x, hf.y), MSG_optBoard
  textausgabe ts, mid(sprachen(sprache), 6, len(sprachen(sprache))-9)
  textausgabe tf, felddaten(spielfeld).name, &h999999-&h666666*(opt=1)
  textausgabe tz, ziel(spielziel), &h999999-&h666666*(opt=1)
  textausgabe tb, felddaten(spielfeld).beschreibung, &h999999-&h666666*(opt=1)
  for i as ubyte = 1 to 10
    m(i) = neuesGrafikfeld(100, 170+30*i, button_minus.x, button_minus.y)
    p(i) = neuesGrafikfeld(300, 170+30*i, button_plus.x, button_plus.y)
    f(i) = neuesGrafikfeld(330, 170+30*i, button_farbe.x, button_farbe.y)
    tp(i) = neuesGrafikfeld(100+button_minus.x, 170+30*i, 200-button_minus.x, button_minus.y)
    m(i+10) = neuesGrafikfeld(450, 170+30*i, button_minus.x, button_minus.y)
    p(i+10) = neuesGrafikfeld(650, 170+30*i, button_plus.x, button_plus.y)
    f(i+10) = neuesGrafikfeld(680, 170+30*i, button_farbe.x, button_farbe.y)
    tp(i+10) = neuesGrafikfeld(450+button_minus.x, 170+30*i, 200-button_minus.x, button_minus.y)
    put (m(i).x, m(i).y), button_minus.grafik, pset
    put (p(i).x, p(i).y), button_plus.grafik, pset
    put (f(i).x, f(i).y), button_farbe.grafik, pset
    put (m(i+10).x, m(i+10).y), button_minus.grafik, pset
    put (p(i+10).x, p(i+10).y), button_plus.grafik, pset
    put (f(i+10).x, f(i+10).y), button_farbe.grafik, pset
  next
  opt_spielerzahlAnpassen(tp(), felddaten(spielfeld).min, felddaten(spielfeld).max)

  ' Einstellungen vornehmen
  do
    do
      getmouse mx, my,, mb
      if inkey = chr(255) & "k" then ende = -1 : exit sub
      sleep 1
    loop until mb = 1
    do
      getmouse m2x, m2y,, mb
      if inkey = chr(255) & "k" then ende = -1 : exit sub
      sleep 1
    loop until mb = 0
    if in(ms, mx, my) and in(ms, m2x, m2y) then
      sprache = (sprache + AnzahlSprachen - 1) mod AnzahlSprachen
      ladeTexte mid(sprachen(sprache), 6, len(sprachen(sprache))-9)
      windowtitle "MonopolZ - " & MSG_optTitle
      textausgabe ts, mid(sprachen(sprache), 6, len(sprachen(sprache))-9)
      textausgabe hh, MSG_optTitle
      textausgabe hs, ""
      textausgabe hf, ""
      textausgabe hz, ""
      draw string (hs.x, hs.y), MSG_optLanguage
      draw string (hf.x, hf.y), MSG_optBoard
      draw string (hz.x, hz.y), MSG_optAim
      ziel(0) = MSG_optAim1
      ziel(1) = msg(MSG_optAim2, 3*felddaten(spielfeld).startgeld & MSG_currency)
      ziel(2) = msg(MSG_optAim2, 5*felddaten(spielfeld).startgeld & MSG_currency)
      ziel(3) = msg(MSG_optAim3, str(100))
      ziel(4) = msg(MSG_optAim3, str(200))
      textausgabe tz, ziel(spielziel), &h999999-&h666666*(opt=1)
      for i = 1 to 20
        if spieler(i).typ = 0 then
          textausgabe tp(i), MSG_optType(0), spieler(i).farbe
        else
          textausgabe tp(i), spieler(i).name & " (" & MSG_optType(spieler(i).typ) & ")", spieler(i).farbe
        end if
      next
    end if
    if in(ps, mx, my) and in(ps, m2x, m2y) then
      sprache = (sprache + 1) mod AnzahlSprachen
      ladeTexte mid(sprachen(sprache), 6, len(sprachen(sprache))-9)
      windowtitle "MonopolZ - " & MSG_optTitle
      textausgabe ts, mid(sprachen(sprache), 6, len(sprachen(sprache))-9)
      textausgabe hh, MSG_optTitle
      textausgabe hs, ""
      textausgabe hf, ""
      textausgabe hz, ""
      draw string (hs.x, hs.y), MSG_optLanguage
      draw string (hf.x, hf.y), MSG_optBoard
      draw string (hz.x, hz.y), MSG_optAim
      ziel(0) = MSG_optAim1
      ziel(1) = msg(MSG_optAim2, 3*felddaten(spielfeld).startgeld & MSG_currency)
      ziel(2) = msg(MSG_optAim2, 5*felddaten(spielfeld).startgeld & MSG_currency)
      ziel(3) = msg(MSG_optAim3, str(100))
      ziel(4) = msg(MSG_optAim3, str(200))
      textausgabe tz, ziel(spielziel), &h999999-&h666666*(opt=1)
      for i = 1 to 20
        if spieler(i).typ = 0 then
          textausgabe tp(i), MSG_optType(0), spieler(i).farbe
        else
          textausgabe tp(i), spieler(i).name & " (" & MSG_optType(spieler(i).typ) & ")", spieler(i).farbe
        end if
      next
    end if
    if in(mf, mx, my) and in(mf, m2x, m2y) and opt=1 then
      spielfeld = (spielfeld + AnzahlSpielfelder - 1) mod AnzahlSpielfelder
      textausgabe tf, felddaten(spielfeld).name
      textausgabe tb, felddaten(spielfeld).beschreibung
      ziel(1) = msg(MSG_optAim2, 3*felddaten(spielfeld).startgeld & MSG_currency)
      ziel(2) = msg(MSG_optAim2, 5*felddaten(spielfeld).startgeld & MSG_currency)
      textausgabe tz, ziel(spielziel)
      opt_spielerzahlAnpassen(tp(), felddaten(spielfeld).min, felddaten(spielfeld).max)
    end if
    if in(pf, mx, my) and in(pf, m2x, m2y) and opt=1 then
      spielfeld = (spielfeld + 1) mod AnzahlSpielfelder
      textausgabe tf, felddaten(spielfeld).name
      textausgabe tb, felddaten(spielfeld).beschreibung
      ziel(1) = msg(MSG_optAim2, 3*felddaten(spielfeld).startgeld & MSG_currency)
      ziel(2) = msg(MSG_optAim2, 5*felddaten(spielfeld).startgeld & MSG_currency)
      textausgabe tz, ziel(spielziel)
      opt_spielerzahlAnpassen(tp(), felddaten(spielfeld).min, felddaten(spielfeld).max)
    end if
    if in(mz, mx, my) and in(mz, m2x, m2y) and opt=1 then
      spielziel = (spielziel + 4) mod 5
      textausgabe tz, ziel(spielziel)
    end if
    if in(pz, mx, my) and in(pz, m2x, m2y) and opt=1 then
      spielziel = (spielziel + 1) mod 5
      textausgabe tz, ziel(spielziel)
    end if
    for i as ubyte = 1 to 20
      if in(m(i), mx, my) and in(m(i), m2x, m2y) then
        if spieler(i).typ = 0 then
          if AnzahlSpieler = felddaten(spielfeld).max or opt<>1 then exit for
          AnzahlSpieler += 1
        end if
        spieler(i).typ = (spieler(i).typ + 4) mod 5
        if spieler(i).typ = 0 then
          if AnzahlSpieler = felddaten(spielfeld).min or opt<>1 then
            spieler(i).typ = 4
          else
            AnzahlSpieler -= 1
          end if
        end if
        if spieler(i).typ = 0 then
          textausgabe tp(i), MSG_optType(0), spieler(i).farbe
        else
          textausgabe tp(i), spieler(i).name & " (" & MSG_optType(spieler(i).typ) & ")", spieler(i).farbe
        end if
      end if
      if in(p(i), mx, my) and in(p(i), m2x, m2y) then
        if spieler(i).typ = 0 then
          if AnzahlSpieler = felddaten(spielfeld).max or opt<>1 then exit for
          AnzahlSpieler += 1
        end if
        spieler(i).typ = (spieler(i).typ + 1) mod 5
        if spieler(i).typ = 0 then
          if AnzahlSpieler = felddaten(spielfeld).min or opt<>1 then
            spieler(i).typ = 1
          else
            AnzahlSpieler -= 1
          end if
        end if
        if spieler(i).typ = 0 then
          textausgabe tp(i), MSG_optType(0), spieler(i).farbe
        else
          textausgabe tp(i), spieler(i).name & " (" & MSG_optType(spieler(i).typ) & ")", spieler(i).farbe
        end if
      end if
      if in(f(i), mx, my) and in(f(i), m2x, m2y) then
        r = spieler(i).farbe shr 16
        g = (spieler(i).farbe shr 8) and 255
        b = spieler(i).farbe and 255
        do
          rgb_plus(r, g, b)
          for k = 1 to 20
            if k <> i and spieler(k).farbe = rgb(r, g, b) then exit for
          next
        loop until k = 21
        spieler(i).farbe = rgb(r, g, b)
        if spieler(i).typ = 0 then
          textausgabe tp(i), MSG_optType(0), spieler(i).farbe
        else
          textausgabe tp(i), spieler(i).name & " (" & MSG_optType(spieler(i).typ) & ")", spieler(i).farbe
        end if
      end if
    next
    if in(nd, mx, my) and in(nd, m2x, m2y) then ende = -1 : exit sub
  loop until in(ok, mx, my) and in(ok, m2x, m2y)

  'Standardeinstellungen speichern
  open "./data/monopolz.ini" for output as datei
  print #1, "language=" & mid(sprachen(sprache), 6, len(sprachen(sprache))-9)
  print #1, "board=" & left(spielfelder(spielfeld), len(spielfelder(spielfeld))-5)
  print #1, "aim=" & spielziel
  for i as ubyte = 1 to 20
    print #1, "name" & i & "=" & spieler(i).name
    print #1, "color" & i & "=" & spieler(i).farbe
    print #1, "type" & i & "=" & spieler(i).typ
  next
  close datei
  ' Feld laden und evtl. Fehler ausgeben
  windowtitle "MonopolZ - " & felddaten(spielfeld).name
  fehler = 0
  cls
  info
  dstring = meldung
  if opt = 1 then
    fehler = neu(spielfelder(spielfeld))
    if fehler = 4 then
      text = MSG_errorFile
    elseif fehler then
      text = MSG_errorPart
    end if
  end if
  if fehler <> 4 then zeichne 0
  if fehler then
    dstring = meldung(text & "\n" & MSG_noteLog)
  elseif opt = 1 then
    dstring = meldung(spielname & "\n" & spielbeschreibung & "\n\n" & msg(MSG_noteAuthor, spielautor))
  end if
  if fehler = 4 then getkey : ende = -1 : exit sub
print #99,5
  if opt = 1 then
    info MSG_noteStart
    dstring = wartetaste
  else
    gesamtinfo
  end if
end sub

sub opt_spielerzahlAnpassen(textfelder() as TypGrafikfeld, byval mini as ubyte, byval maxi as ubyte)
  ' Spielerzahl an minplayer und maxplayer anpassen sowie Namen ausgeben
  i = 20
  do while AnzahlSpieler > maxi and i > 0
    if spieler(i).typ > 0 then
      spieler(i).typ = 0
      AnzahlSpieler -= 1
    end if
    i -= 1
  loop
  i = 1
  do while AnzahlSpieler < mini and i < 21
    if spieler(i).typ = 0 then
      spieler(i).typ = 3
      AnzahlSpieler += 1
    end if
    i += 1
  loop
  for i = 1 to 20
    if spieler(i).typ = 0 then
      textausgabe textfelder(i), MSG_optType(0), spieler(i).farbe
    else
      textausgabe textfelder(i), spieler(i).name & " (" & MSG_optType(spieler(i).typ) & ")", spieler(i).farbe
    end if
  next
end sub

sub rgb_plus(byref r as ubyte, byref g as ubyte, byref b as ubyte)
  if b = 0 then b = 127 : exit sub
  if b = 127 then
    if r = 255 and g = 255 then
      r = 0 : g = 0 : b = 127
    else
     b = 255
    end if
    exit sub
  end if
  b = 0
  if g = 0 then g = 127 : exit sub
  if g = 127 then g = 255 : exit sub
  g = 0
  if r = 0 then r = 127 : exit sub
  if r = 127 then r = 255 : exit sub
  r = 0
  b = 127
end sub
